local nkUIInfo, nkUI = ...

function nkUI.nkCheckbox(name, parent) 

	local defaultLabelColor = {1, 1, 1, 1}
	local defaultElementColor = {1, 1, 1, 1}	

	local checkBox = UI.CreateFrame ('Frame', name, parent)
	local label = UI.CreateFrame ('Text', name, checkBox)
	local boxOuter = UI.CreateFrame ('Frame', name, checkBox)
	local boxInner = UI.CreateFrame ('Frame', name, boxOuter)
	local boxMark = UI.CreateFrame ('Frame', name, boxInner)

	local properties = {}

	function checkBox:SetValue(property, value)
		properties[property] = value
	end
	
	function checkBox:GetValue(property)
		return properties[property]
	end
	
	checkBox:SetValue("name", name)
	checkBox:SetValue("parent", parent)

	checkBox:SetValue("checked", false)
	
	checkBox:SetHeight(13)
	checkBox:SetWidth(113)
	
	boxOuter:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		checkBox:toggle()
	end, name .. "boxOutter_LeftClick")	
	
	label:SetPoint("CENTERLEFT", checkBox, "CENTERLEFT")
	label:SetWidth(100)
	label:SetFontSize(13)
	label:SetFontColor(defaultLabelColor[1], defaultLabelColor[2], defaultLabelColor[3], defaultLabelColor[4])
	
	--label:SetText(checkBox:GetValue("label"))
	
	boxOuter:SetPoint("CENTERLEFT", label, "CENTERRIGHT")
	boxOuter:SetWidth(13)
	boxOuter:SetHeight(13)
		
	boxOuter:SetBackgroundColor(defaultElementColor[1], defaultElementColor[2], defaultElementColor[3], defaultElementColor[4])
	
	boxInner:SetPoint("TOPLEFT", boxOuter, "TOPLEFT", 1, 1)
	boxInner:SetPoint("BOTTOMRIGHT", boxOuter, "BOTTOMRIGHT", -1, -1)
	boxInner:SetBackgroundColor(0, 0, 0, 1)	
	
	boxMark:SetPoint("TOPLEFT", boxInner, "TOPLEFT", 2, 2)
	boxMark:SetPoint("BOTTOMRIGHT", boxInner, "BOTTOMRIGHT", -2, -2)
	boxMark:SetBackgroundColor(defaultElementColor[1], defaultElementColor[2], defaultElementColor[3], defaultElementColor[4])
	
	function checkBox:toggle ()
		local checked = self:GetValue('checked')
		if checked == true then checked = false else checked = true end
		self:SetChecked(checked)
	end

	function checkBox:SetChecked(flag)
		self:SetValue('checked', flag)
		boxMark:SetVisible(flag)
		Library.nkUI.handler[name]["CheckboxChanged"]( flag )
	end
	
	Library.nkUI.handler[name] = {}
	Library.nkUI.Event[name] = {}
	Library.nkUI.handler[name]["CheckboxChanged"], Library.nkUI.Event[name]["CheckboxChanged"] = Utility.Event.Create(nkUIInfo.identifier, name .. "CheckboxChanged")
		
	function checkBox:GetChecked () return self:GetValue('checked') end

	function checkBox:SetLabelInFront(flag)

		self:SetValue("labelInFront", flag)
			
		if flag == true then
			label:SetPoint("CENTERLEFT", checkBox, "CENTERLEFT")
			boxOuter:SetPoint("CENTERLEFT", label, "CENTERRIGHT", 5, 0)
		else
			boxOuter:SetPoint("CENTERLEFT", checkBox, "CENTERLEFT")
			label:SetPoint("CENTERLEFT", boxOuter, "CENTERRIGHT", 5, 0)
		end

	end

	function checkBox:SetLabelColor(r, g, b, a) label:SetFontColor (r, g, b, a) end
	
	function checkBox:SetColor(r, g, b, a) 
		boxOuter:SetBackgroundColor (r, g, b, a) 		
		boxMark:SetBackgroundColor (r, g, b, a) 
	end

	function checkBox:SetText(text) label:SetText(text) end	
	
	function checkBox:SetLabelWidth(width)
		checkBox:SetWidth(width + 13)
		label:SetWidth(width)
	end
	
	return checkBox
	
end