local nkUIInfo, nkUI = ...

function nkUI.nkDialog(name, parent) 

	local dialog = nkUICreateFrame("nkWindow", name, parent)
	local message = UI.CreateFrame ('Text', name .. "message", dialog)
	local leftButton = UI.CreateFrame ('RiftButton', name .. "leftButton", dialog)
	local centerButton = UI.CreateFrame ('RiftButton', name .. "leftButton", dialog)
	local rightButton = UI.CreateFrame ('RiftButton', name .. "rightButton", dialog)

	local properties = {}

	function dialog:SetValue(property, value)
		properties[property] = value
	end
	
	function dialog:GetValue(property)
		return properties[property]
	end
	
	dialog:SetValue("name", name)
	dialog:SetValue("parent", parent)

	dialog:SetDragable(true)
	dialog:SetCloseable(true)
	dialog:SetStrata('main')
	dialog:SetTitle("")
	dialog:SetPoint("CENTER", UIParent, "CENTER")
	
	message:SetPoint("CENTER", dialog:GetContent(), "CENTER", 0, -30)
	message:SetFontColor(1, 1, 1, 1)
	message:SetFontSize(16)
	message:SetWordwrap(true)
	--message:SetBackgroundColor (0, 0,0 ,1)
	
	leftButton:SetPoint("BOTTOMLEFT", dialog:GetContent(), "BOTTOMLEFT", 5, -5)
	
	leftButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		dialog:SetVisible(false)
		Library.nkUI.handler[name]["LeftButtonClicked"]()
	end, name .. "_leftButton_LeftClick")
	
	centerButton:SetPoint("BOTTOMCENTER", dialog:GetContent(), "BOTTOMCENTER", 0, -5)
	
	centerButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		dialog:SetVisible(false)
		Library.nkUI.handler[name]["CenterButtonClicked"]()
	end, name .. "_centerButton_LeftClick")
	
	rightButton:SetPoint("BOTTOMRIGHT", dialog:GetContent(), "BOTTOMRIGHT", -5, -5)
	
	rightButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		dialog:SetVisible(false)
		Library.nkUI.handler[name]["RightButtonClicked"]()
	end, name .. "_rightButton_LeftClick")
	
	function dialog:SetType(dialogType)
	
		if dialogType == "confirm" then
			leftButton:SetText(nkUI.langTexts.yes)
			rightButton:SetText(nkUI.langTexts.no)
			leftButton:SetVisible(true)
			rightButton:SetVisible(true)
			centerButton:SetVisible(false)
		else
			centerButton:SetText(nkUI.langTexts.ok)			
			leftButton:SetVisible(false)
			rightButton:SetVisible(false)
			centerButton:SetVisible(true)
		end
	
	end
	
	function dialog:SetMessage(messageText)
		message:SetText(messageText)
		message:SetWidth(message:GetWidth())
	end
	
	local oSetWidth, oSetHeight = dialog.SetWidth, dialog.SetHeight
	
	function dialog:SetWidth(width)
		oSetWidth(self, width)
		message:SetWidth( width - 40)
	end
	
	function dialog:SetHeight(height)
		oSetHeight(self, height)
		message:SetHeight( height - 120)
	end
	
	Library.nkUI.handler[name] = {}
	Library.nkUI.Event[name] = {}
	Library.nkUI.handler[name]["LeftButtonClicked"], Library.nkUI.Event[name]["LeftButtonClicked"] = Utility.Event.Create(nkUIInfo.identifier, name .. "LeftButtonClicked")
	Library.nkUI.handler[name]["RightButtonClicked"], Library.nkUI.Event[name]["RightButtonClicked"] = Utility.Event.Create(nkUIInfo.identifier, name .. "RightButtonClicked")
	Library.nkUI.handler[name]["CenterButtonClicked"], Library.nkUI.Event[name]["CenterButtonClicked"] = Utility.Event.Create(nkUIInfo.identifier, name .. "CenterButtonClicked")
	
	return dialog
	
end