local nkRWardrobeInfo, nkRWardrobe = ...

nkRWardrobe.privateVars = {}

nkRWardrobe.privateVars.addonName = "nkRWardrobe Reloaded"
nkRWardrobe.privateVars.addonVersion = "1.0.2"

nkRWardrobe.UIelements = {}
nkRWardrobe.UIelements.context = UI.CreateContext("nkRWardrobe")
nkRWardrobe.UIelements.context:SetSecureMode('restricted')
nkRWardrobe.UIelements.context:SetStrata ('dialog')

nkRWardrobe.UIelements.dialogContext = UI.CreateContext("nkRWardrobe")
nkRWardrobe.UIelements.dialogContext:SetStrata ('topmost')

nkRWardrobe.UIelements.tooltipContext = UI.CreateContext("nkRWardrobe")
nkRWardrobe.UIelements.tooltipContext:SetStrata ('topmost')

function nkRWardrobe.startup()

	if (nkRWardrobe.init == nil) then

		if nkRWardrobe.privateVars.calling == nil then
			local userDetails = Inspect.Unit.Detail ('player')
			nkRWardrobe.privateVars.calling = userDetails.calling
		end

		if nkRWardrobe.privateVars.calling ~= nil then
		
			nkRWardrobe.UIExtension()
		
			if nkRWSetup.button == true and nkRWardrobe.UIelements.macroButton == nil then nkRWardrobe.UIelements.macroButton = nkRWardrobe.Button() end	

			Command.Event.Attach(Event.Tooltip, nkRWardrobe.tooltipInfo, "Tooltip Handler")
			
			nkRWardrobe.init = true
			
			print (string.format(nkRWardrobe.langTexts.msgLoaded, nkRWardrobe.privateVars.addonVersion))		
		end
	end
	
end

function nkRWardrobe.commandHandler(commandline)

       if string.find(commandline, 'equip=') ~= nil then
		   local pos = string.find(commandline, 'equip=')
		   local selset=string.sub(commandline, pos+6, string.len(commandline))
		   local setno = tonumber(selset)
		   
		   for k,v in pairs(nkRWSetup.sets) do
				if v.name == selset then
				   setno = k
					break
			   end
		   end
		   if setno < 1 or setno > #nkRWSetup.sets then
			   print (string.format(nkRWardrobe.langTexts.commandSetRefuse, setno, #nkRWSetup.sets ))
		   else
			   nkRWardrobe.wearEquip (setno)
		   end
       else
            if nkRWardrobe.UIelements.configUI == nil then nkRWardrobe.UIelements.configUI = nkRWardrobe.Config:new() else nkRWardrobe.UIelements.configUI:Show(true) end
       end

end

function nkRWardrobe.settingsHandler() 
	
	local settings = {		
		open = 'bottom',
		border = true,
		scale = 80,
		activeSet = 1,
		button = true,
		buttonX = -190,
		buttonY = 260,
		currentSet = 1,
		sets = { {name = string.format(nkRWardrobe.langTexts.set, 1), role = 1, bag = 1, bank = 0, icon = 'ressource/equipEmptyhandmain.png' , items = {} } }
	}
	
	if nkRWSetup == nil then
		nkRWSetup = settings
	else
		for k, v in pairs (settings) do if nkRWSetup[k] == nil then nkRWSetup[k] = v end end
	end
		
	nkRWSetup.version = nkRWardrobe.privateVars.addonVersion
	
	nkRWardrobe.privateVars.uiSelectedSet = nkRWSetup.activeSet or 1
			
end

Command.Event.Attach(Event.Unit.Availability.Full, nkRWardrobe.startup, "nkRWardrobe_systemLoaded")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, nkRWardrobe.settingsHandler, "nkRWardrobe_variablesLoaded")

table.insert(Command.Slash.Register("nkRWardrobe"), {nkRWardrobe.commandHandler, "nkRWardrobe", "commandHandler"})
table.insert(Command.Slash.Register("nkw"), {nkRWardrobe.commandHandler, "nkRWardrobe", "commandHandler"})

--------------------------------------------------------------------------------------------------------------------------------------------

function nkRWardrobe.wearEquip (setNo)

	if nkRWSetup.sets[setNo].name ~= nil then
		print(string.format(nkRWardrobe.langTexts.loadSet, nkRWSetup.sets[setNo].name))
	else
		print(string.format(nkRWardrobe.langTexts.loadSet, tostring(setNo)))
	end
	
	nkRWardrobe.initMove = math.floor(Inspect.Time.Frame())
		
	for k, v in pairs (nkRWSetup.sets[setNo].items) do
		local err, sourceSlot = pcall(Inspect.Item.Find, v)
			
		if err then		
			local slot = Utility.Item.Slot.Equipment(k)
			if sourceSlot ~= slot then pcall (Command.Item.Move, sourceSlot, slot) end
		else
			local itemDetails = Inspect.Item.Detail(v)
			print (string.format(nkRWardrobe.langTexts.errGettingItem, itemDetails.name))
		end
	end
	
	nkRWardrobe.extUI.setSelect:SetSelectedValue(setNo)

end