local nkRWardrobeInfo, nkRWardrobe = ...

--==================== BUILD CHARACTER SCREEN ====================

function nkRWardrobe.UIExtension ()

	local labelColor = {0.886, 0.835, 0.576, 1}
	local elementColor = {0.557, 0.514, 0.357, 1}

	-- ***** WINDOW *****

	nkRWardrobe.extUI = nkUICreateFrame("nkWindow", "nkRW_char_window", nkRWardrobe.UIelements.context)	
	nkRWardrobe.extUI:SetCloseable(true)
	nkRWardrobe.extUI:SetTitle(nkRWardrobe.privateVars.addonName)
	nkRWardrobe.extUI:SetPoint("TOPLEFT", UI.Native.Character, "TOPRIGHT")
	nkRWardrobe.extUI:SetVisible(false)
	nkRWardrobe.extUI:SetLayer(1)
	nkRWardrobe.extUI:SetSecureMode('restricted')
	nkRWardrobe.extUI:SetWidth(375)
	nkRWardrobe.extUI:SetHeight(525)
	
	-- ***** set selection *****
	
	-- set selection: label
	
	nkRWardrobe.extUI.setLabel = UI.CreateFrame("Text", "nkRW_cw_setLabel", nkRWardrobe.extUI)
	nkRWardrobe.extUI.setLabel:SetWidth(100)
	nkRWardrobe.extUI.setLabel:SetFontSize(13)
	nkRWardrobe.extUI.setLabel:SetText(nkRWardrobe.langTexts.setLabel)
	nkRWardrobe.extUI.setLabel:SetFontColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.setLabel:SetPoint("TOPLEFT", nkRWardrobe.extUI:GetContent(), "TOPLEFT", 5, 0)
	
	-- set selection: selection box
	
	local selItems= {}
	
	if nkRWSetup.sets[1] == nil then nkRWSetup.sets[1] = { name = string.format(nkRWardrobe.langTexts.txtEquipment, 1) } end
		
	for k, v in pairs (nkRWSetup.sets) do
		table.insert (selItems, { label = v.name, value = k })
	end
	
	nkRWardrobe.extUI.setSelect = nkUICreateFrame("nkCombobox", "nkRW_cw_setSelect", nkRWardrobe.extUI)
	nkRWardrobe.extUI.setSelect:SetPoint("CENTERLEFT", nkRWardrobe.extUI.setLabel, "CENTERRIGHT")
	nkRWardrobe.extUI.setSelect:SetLayer(9)
	nkRWardrobe.extUI.setSelect:SetWidth(200)
	nkRWardrobe.extUI.setSelect:SetSelection(selItems)
	nkRWardrobe.extUI.setSelect:SetSelectedValue(nkRWardrobe.privateVars.uiSelectedSet, false)
	nkRWardrobe.extUI.setSelect:SetColor (elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	nkRWardrobe.extUI.setSelect:SetLabelColor (labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_setSelect.ComboChanged, function (_, newValue)
		nkRWardrobe.privateVars.uiSelectedSet = newValue.value
		nkRWardrobe.UpdateUIOnSetChange(newValue.value)
	end, "nkRW_cw_setSelect.ComboChanged")
	
	--- set selection: edit icon
	
	nkRWardrobe.extUI.setEditIcon = UI.CreateFrame('Texture', 'nkRW_cw_setSelectsetEditIcon', nkRWardrobe.extUI)	
	nkRWardrobe.extUI.setEditIcon:SetTextureAsync("nkRWardrobe", "gfx/editPen.png")	
	nkRWardrobe.extUI.setEditIcon:SetWidth(15)
	nkRWardrobe.extUI.setEditIcon:SetHeight(15)
	nkRWardrobe.extUI.setEditIcon:SetPoint("CENTERLEFT", nkRWardrobe.extUI.setSelect, "CENTERRIGHT", 5, 0)
	
	nkRWardrobe.extUI.setEditIcon:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		if nkRWardrobe.extUI.setNameEdit:GetVisible() == true then			
			nkRWardrobe.extUI.setEditIcon:SetPoint("CENTERLEFT", nkRWardrobe.extUI.setSelect, "CENTERRIGHT", 5, 0)			
			nkRWardrobe.extUI.setNameEdit:SetKeyFocus(false)
			nkRWardrobe.extUI.setSelect:SetVisible(true)
			nkRWardrobe.extUI.setNameEdit:SetVisible(false)
		else
			nkRWardrobe.extUI.setNameEdit:SetText(nkRWardrobe.extUI.setSelect:GetSelectedLabel())
			nkRWardrobe.extUI.setEditIcon:SetPoint ("CENTERLEFT", nkRWardrobe.extUI.setNameEdit, "CENTERRIGHT", 5, 0)
			nkRWardrobe.extUI.setSelect:SetVisible(false)
			nkRWardrobe.extUI.setNameEdit:SetVisible(true)
		end
	end, "nkRW_cw_setSelectsetEditIcon_LeftClick")
	
	-- set selection: edit field
	
	nkRWardrobe.extUI.setNameEdit = nkUICreateFrame("nkTextfield", "nkRW_cw_setNameEdit", nkRWardrobe.extUI)
	nkRWardrobe.extUI.setNameEdit:SetVisible(false)
	nkRWardrobe.extUI.setNameEdit:SetWidth(200)
	nkRWardrobe.extUI.setNameEdit:SetHeight(20)
	nkRWardrobe.extUI.setNameEdit:SetText(nkRWSetup.sets[1].name)
	nkRWardrobe.extUI.setNameEdit:SetPoint("CENTERLEFT", nkRWardrobe.extUI.setLabel, "CENTERRIGHT")
	nkRWardrobe.extUI.setNameEdit:SetColor(elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_setNameEdit.TextfieldChanged, function ()		
		nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].name = nkRWardrobe.extUI.setNameEdit:GetText()
		nkRWardrobe.UpdateSetSelectValues()
		
		nkRWardrobe.extUI.setEditIcon:SetPoint("CENTERLEFT", nkRWardrobe.extUI.setSelect, "CENTERRIGHT", 5, 0)
		nkRWardrobe.extUI.setSelect:SetVisible(true)
		nkRWardrobe.extUI.setNameEdit:SetVisible(false)
	end, "nkRW_cw_ShowButtonCheckbox.CheckboxChanged")
		
	-- ***** role selection *****
	
	-- role selection: label
	
	nkRWardrobe.extUI.roleLabel = UI.CreateFrame("Text", "nkRW_cw_roleLabel", nkRWardrobe.extUI)
	nkRWardrobe.extUI.roleLabel:SetWidth(100)
	nkRWardrobe.extUI.roleLabel:SetFontSize(13)
	nkRWardrobe.extUI.roleLabel:SetText(nkRWardrobe.langTexts.fldRole)
	nkRWardrobe.extUI.roleLabel:SetFontColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.roleLabel:SetPoint("TOPLEFT", nkRWardrobe.extUI.setLabel, "BOTTOMLEFT", 0, 5)
		
	local selValues = { { label = nkRWardrobe.langTexts.roleNon , value = 0 }}
	
	for idx = 1, 20, 1 do
		table.insert(selValues, { label = string.format(nkRWardrobe.langTexts.txtRole, idx), value = idx })
	end	
	
	-- role selection: selection box
	
	nkRWardrobe.extUI.roleSelect = nkUICreateFrame("nkCombobox", "nkRW_cw_roleSelect", nkRWardrobe.extUI)
	nkRWardrobe.extUI.roleSelect:SetPoint("CENTERLEFT", nkRWardrobe.extUI.roleLabel, "CENTERRIGHT")
	nkRWardrobe.extUI.roleSelect:SetWidth(200)
	nkRWardrobe.extUI.roleSelect:SetSelection(selValues)
	nkRWardrobe.extUI.roleSelect:SetSelectedValue(nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].role, false)
	nkRWardrobe.extUI.roleSelect:SetLayer(8)
	nkRWardrobe.extUI.roleSelect:SetColor (elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	nkRWardrobe.extUI.roleSelect:SetLabelColor (labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_roleSelect.ComboChanged, function (_, newValue)
		nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].role = newValue.value
	end, "nkRW_cw_roleSelect.ComboChanged")
	
	-- ***** icon selection *****
		
	-- icon selection: label
		
	nkRWardrobe.extUI.iconLabel = UI.CreateFrame("Text", "nkRW_cw_iconLabel", nkRWardrobe.extUI)
	nkRWardrobe.extUI.iconLabel:SetWidth(100)
	nkRWardrobe.extUI.iconLabel:SetFontSize(13)
	nkRWardrobe.extUI.iconLabel:SetText(nkRWardrobe.langTexts.fldIcon)
	nkRWardrobe.extUI.iconLabel:SetFontColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.iconLabel:SetPoint("TOPLEFT", nkRWardrobe.extUI.roleLabel, "BOTTOMLEFT", 0, 5)
	
	-- icon selection: selection box
	
	local selValues = nkRWardrobe.langTexts.souls[nkRWardrobe.privateVars.calling]
	table.insert(selValues, { label = nkRWardrobe.langTexts.msgChoose, value = '', iconPath = '', iconType = '' })
	
	local slot = Utility.Item.Slot.All()
	local items = Inspect.Item.Detail (slot)
	
	for k, v in pairs (items) do				
		table.insert (selValues, { label = v.name, value = v.icon, iconPath = v.icon, iconType = 'Rift' })
	end
	
	nkRWardrobe.extUI.iconSelect = nkUICreateFrame("nkCombobox", "nkRW_cw_iconSelect", nkRWardrobe.extUI)
	nkRWardrobe.extUI.iconSelect:SetPoint("CENTERLEFT", nkRWardrobe.extUI.iconLabel, "CENTERRIGHT")
	nkRWardrobe.extUI.iconSelect:SetWidth(200)
	nkRWardrobe.extUI.iconSelect:SetSelection(selValues)
	nkRWardrobe.extUI.iconSelect:SetSelectedValue(nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].icon, false)
	nkRWardrobe.extUI.iconSelect:SetLayer(7)
	nkRWardrobe.extUI.iconSelect:SetColor (elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	nkRWardrobe.extUI.iconSelect:SetLabelColor (labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_iconSelect.ComboChanged, function (_, newValue)
		nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].icon = newValue.iconPath
	end, "nkRW_cw_iconSelect.ComboChanged")
	
	-- ***** equipment buttons *****
	
	-- equipment buttons: wear set
	
	nkRWardrobe.extUI.WearSetButton = UI.CreateFrame("RiftButton", "nkRW_cw_WearSetButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.WearSetButton:SetPoint("TOPLEFT", nkRWardrobe.extUI.iconLabel, "BOTTOMLEFT", 20, 10)
	nkRWardrobe.extUI.WearSetButton:SetText(nkRWardrobe.langTexts.btWearEquip)
	
	nkRWardrobe.extUI.WearSetButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.WearEquip(nkRWardrobe.privateVars.uiSelectedSet) 
	end, "nkRW_cw_WearSetButton_LeftClick")
	
	-- equipment buttons: store current equip
	
	nkRWardrobe.extUI.StoreEquipButton = UI.CreateFrame("RiftButton", "nkRW_cw_StoreEquipButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.StoreEquipButton:SetPoint("CENTERLEFT", nkRWardrobe.extUI.WearSetButton, "CENTERRIGHT", 25, 0)
	nkRWardrobe.extUI.StoreEquipButton:SetText(nkRWardrobe.langTexts.btLoadFromEquip)
	
	nkRWardrobe.extUI.StoreEquipButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.StoreEquip(nkRWardrobe.privateVars.uiSelectedSet)
	end, "nkRW_cw_StoreEquipButton_LeftClick")
	
	-- ***** bag & bank *****
	
	-- bag & bank: bag slot selection
	
	local selValues = {}
	
	for idx = 1, 7, 1 do 
		table.insert(selValues, { label = string.format ( nkRWardrobe.langTexts.txtBag, idx), value = idx })
	end
	
	nkRWardrobe.extUI.bagSelect = nkUICreateFrame("nkCombobox", "nkRW_cw_bagSelect", nkRWardrobe.extUI)
	nkRWardrobe.extUI.bagSelect:SetPoint("TOPCENTER", nkRWardrobe.extUI.WearSetButton, "BOTTOMCENTER", 0, 10)
	nkRWardrobe.extUI.bagSelect:SetSelection(selValues)
	nkRWardrobe.extUI.bagSelect:SetSelectedValue(nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].bag, false)
	nkRWardrobe.extUI.bagSelect:SetLayer(6)
	nkRWardrobe.extUI.bagSelect:SetColor (elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	nkRWardrobe.extUI.bagSelect:SetLabelColor (labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_bagSelect.ComboChanged, function (_, newValue)
		nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].bag = newValue.value
	end, "nkRW_cw_bagSelect.ComboChanged")
	
	-- bag & bank: bank slot selection
	
	local selValues = {}
	table.insert(selValues, { label = nkRWardrobe.langTexts.mainBankSlot, value = 0 })
	
	for idx = 1, 8, 1 do 
		table.insert(selValues, { label = string.format ( nkRWardrobe.langTexts.txtBank, idx ), value = idx })
	end	
	
	nkRWardrobe.extUI.bankSelect = nkUICreateFrame("nkCombobox", "nkRW_cw_bankSelect", nkRWardrobe.extUI)
	nkRWardrobe.extUI.bankSelect:SetPoint("TOPCENTER", nkRWardrobe.extUI.StoreEquipButton, "BOTTOMCENTER", 0, 10)
	nkRWardrobe.extUI.bankSelect:SetSelection(selValues)
	nkRWardrobe.extUI.bankSelect:SetSelectedValue(nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].bank, false)
	nkRWardrobe.extUI.bankSelect:SetLayer(6)
	nkRWardrobe.extUI.bankSelect:SetColor (elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	nkRWardrobe.extUI.bankSelect:SetLabelColor (labelColor[1], labelColor[2], labelColor[3], labelColor[4])

	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_bankSelect.ComboChanged, function (_, newValue)
		nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].bank = newValue.value
	end, "nkRW_cw_bankSelect.ComboChanged")
	
	-- bag & bank: get from bank button
	
	nkRWardrobe.extUI.GetFromBankButton = UI.CreateFrame("RiftButton", "nkRW_cw_GetFromBankButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.GetFromBankButton:SetPoint("TOPCENTER", nkRWardrobe.extUI.WearSetButton, "BOTTOMCENTER", 0, 45)
	nkRWardrobe.extUI.GetFromBankButton:SetText(nkRWardrobe.langTexts.btGetFromBank)
	
	nkRWardrobe.extUI.GetFromBankButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.GetEquipFromBank()
	end, "nkRW_cw_GetFromBankButton_LeftClick")
	
	-- bag & bank: put to bank button
	
	nkRWardrobe.extUI.PutToBankButton = UI.CreateFrame("RiftButton", "nkRW_cw_PutToBankButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.PutToBankButton:SetPoint("TOPCENTER", nkRWardrobe.extUI.StoreEquipButton, "BOTTOMCENTER", 0, 45)
	nkRWardrobe.extUI.PutToBankButton:SetText(nkRWardrobe.langTexts.btGetFromBank)
	
	nkRWardrobe.extUI.PutToBankButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.PutEquipToBank()
	end, "nkRW_cw_PutToBankButton_LeftClick")

	-- ***** set management *****
	
	-- set management: add set button
	
	nkRWardrobe.extUI.AddSetButton = UI.CreateFrame("RiftButton", "nkRW_cw_AddSetButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.AddSetButton:SetPoint("TOPCENTER", nkRWardrobe.extUI.GetFromBankButton, "BOTTOMCENTER", 0, 10)
	nkRWardrobe.extUI.AddSetButton:SetText(nkRWardrobe.langTexts.btAddSet)
	
	nkRWardrobe.extUI.AddSetButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.SetAdd()
	end, "nkRW_cw_AddSetButton_LeftClick")
	
	-- set management: remove set button
	
	nkRWardrobe.extUI.RemoveSetButton = UI.CreateFrame("RiftButton", "nkRW_cw_RemoveSetButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.RemoveSetButton:SetPoint("TOPCENTER", nkRWardrobe.extUI.PutToBankButton, "BOTTOMCENTER", 0, 10)
	nkRWardrobe.extUI.RemoveSetButton:SetText(nkRWardrobe.langTexts.btRemoveSet)
	
	nkRWardrobe.extUI.RemoveSetButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.SetRemove()
	end, "nkRW_cw_RemoveSetButton_LeftClick")
	
	-- set management: copy set button

	nkRWardrobe.extUI.CopySetButton = UI.CreateFrame("RiftButton", "nkRW_cw_CopySetButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.CopySetButton:SetPoint("TOPLEFT", nkRWardrobe.extUI:GetContent(), "TOPLEFT", 100, 240)
	nkRWardrobe.extUI.CopySetButton:SetText(nkRWardrobe.langTexts.btCopySet)
	
	nkRWardrobe.extUI.CopySetButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.SetCopy() 
	end, "nkRW_cw_CopySetButton_LeftClick")

	-- ***** basic configuration *****
	
	-- set management: show button checkbox
	
	nkRWardrobe.extUI.ShowButtonCheckbox = nkUICreateFrame("nkCheckbox", "nkRW_cw_ShowButtonCheckbox", nkRWardrobe.extUI)	
	nkRWardrobe.extUI.ShowButtonCheckbox:SetPoint("TOPLEFT", nkRWardrobe.extUI.AddSetButton, "BOTTOMLEFT", -20, 60)
	nkRWardrobe.extUI.ShowButtonCheckbox:SetText(nkRWardrobe.langTexts.cbButton)
	nkRWardrobe.extUI.ShowButtonCheckbox:SetChecked(nkRWSetup.button)
	nkRWardrobe.extUI.ShowButtonCheckbox:SetLabelColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.ShowButtonCheckbox:SetColor(elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_ShowButtonCheckbox.CheckboxChanged, function (_, newValue)		
		nkRWSetup.button = newValue
		if newValue == true and nkRWardrobe.UIelements.macroButton == nil then nkRWardrobe.UIelements.macroButton = nkRWardrobe.Button() end
		if nkRWardrobe.UIelements.macroButton ~= nil then nkRWardrobe.UIelements.macroButton:SetVisible(nkRWSetup.button) end
	end, "nkRW_cw_ShowButtonCheckbox.CheckboxChanged")
	
	-- set management: show border checkbox
	
	nkRWardrobe.extUI.ShowBorderCheckbox = nkUICreateFrame("nkCheckbox", "nkRW_cw_ShowBorderCheckbox", nkRWardrobe.extUI)	
	nkRWardrobe.extUI.ShowBorderCheckbox:SetPoint("CENTERLEFT", nkRWardrobe.extUI.ShowButtonCheckbox, "CENTERRIGHT", 10, 0)
	nkRWardrobe.extUI.ShowBorderCheckbox:SetText(nkRWardrobe.langTexts.cbBorder)
	nkRWardrobe.extUI.ShowBorderCheckbox:SetChecked(nkRWSetup.border)
	nkRWardrobe.extUI.ShowBorderCheckbox:SetLabelColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.ShowBorderCheckbox:SetColor(elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_ShowBorderCheckbox.CheckboxChanged, function (_, newValue)		
		nkRWSetup.border = newValue
		if nkRWardrobe.UIelements.macroButton ~= nil then nkRWardrobe.UIelements.macroButton:Update() end
	end, "nkRW_cw_ShowBorderCheckbox.CheckboxChanged")
	
	-- set management: open direction label
	
	nkRWardrobe.extUI.openDirLabel = UI.CreateFrame("Text", "nkRW_cw_openDirLabel", nkRWardrobe.extUI)
	nkRWardrobe.extUI.openDirLabel:SetWidth(100)
	nkRWardrobe.extUI.openDirLabel:SetFontSize(13)
	nkRWardrobe.extUI.openDirLabel:SetText(nkRWardrobe.langTexts.fldOpen)
	nkRWardrobe.extUI.openDirLabel:SetFontColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.openDirLabel:SetPoint("TOPLEFT", nkRWardrobe.extUI.ShowButtonCheckbox, "BOTTOMLEFT", 0, 8)
		
	-- set management: open direction select
	
	local selValues = {{ label = nkRWardrobe.langTexts.openTop, value = 'top'}, { label = nkRWardrobe.langTexts.openBottom, value = 'bottom'}, { label = nkRWardrobe.langTexts.openLeft, value = 'left'}, { label =nkRWardrobe.langTexts.openRight, value = 'right'}}
		
	nkRWardrobe.extUI.openDirSelect = nkUICreateFrame("nkCombobox", "nkRW_cw_openDirSelect", nkRWardrobe.extUI)
	nkRWardrobe.extUI.openDirSelect:SetPoint("CENTERLEFT", nkRWardrobe.extUI.openDirLabel, "CENTERRIGHT")
	nkRWardrobe.extUI.openDirSelect:SetSelection(selValues)
	nkRWardrobe.extUI.openDirSelect:SetSelectedValue(nkRWSetup.open, false)
	nkRWardrobe.extUI.openDirSelect:SetLayer(6)
	nkRWardrobe.extUI.openDirSelect:SetColor (elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	nkRWardrobe.extUI.openDirSelect:SetLabelColor (labelColor[1], labelColor[2], labelColor[3], labelColor[4])

	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_openDirSelect.ComboChanged, function (_, newValue)
		nkRWSetup.open = newValue.value
		if nkRWardrobe.UIelements.macroButton ~= nil then nkRWardrobe.UIelements.macroButton:ReAlign() end
	end, "nkRW_cw_openDirSelect.ComboChanged")

	-- set management: scale label
	
	nkRWardrobe.extUI.scaleLabel = UI.CreateFrame("Text", "nkRW_cw_scaleLabel", nkRWardrobe.extUI)
	nkRWardrobe.extUI.scaleLabel:SetWidth(100)
	nkRWardrobe.extUI.scaleLabel:SetFontSize(13)
	nkRWardrobe.extUI.scaleLabel:SetText(string.format(nkRWardrobe.langTexts.slScale, nkRWSetup.scale))
	nkRWardrobe.extUI.scaleLabel:SetFontColor(labelColor[1], labelColor[2], labelColor[3], labelColor[4])
	nkRWardrobe.extUI.scaleLabel:SetPoint("TOPLEFT", nkRWardrobe.extUI.openDirLabel, "BOTTOMLEFT", 0, 5)
	
	-- set management: scale slider
	
	nkRWardrobe.extUI.scaleSlider = nkUICreateFrame("nkSlider", "nkRW_cw_scaleSlider", nkRWardrobe.extUI)
	nkRWardrobe.extUI.scaleSlider:SetPoint("CENTERLEFT", nkRWardrobe.extUI.scaleLabel, "CENTERRIGHT")
	nkRWardrobe.extUI.scaleSlider:SetWidth(100)
	nkRWardrobe.extUI.scaleSlider:SetRange(0, 150)
	nkRWardrobe.extUI.scaleSlider:AdjustValue(nkRWSetup.scale)
	nkRWardrobe.extUI.scaleSlider:SetColor(elementColor[1], elementColor[2], elementColor[3], elementColor[4])
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_cw_scaleSlider.SliderChanged, function (_, newValue)
		nkRWSetup.scale = newValue
		nkRWardrobe.extUI.scaleLabel:SetText(string.format(nkRWardrobe.langTexts.slScale, nkRWSetup.scale))
		if nkRWardrobe.UIelements.macroButton ~= nil then nkRWardrobe.UIelements.macroButton:Update() end		
	end, "nkRW_cw_scaleSlider.SliderChanged")

	-- ***** bottom button array *****
	
	-- bottom button array: about button
	
	nkRWardrobe.extUI.aboutButton = UI.CreateFrame("RiftButton", "nkRW_cw_aboutButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.aboutButton:SetPoint("BOTTOMLEFT", nkRWardrobe.extUI:GetContent(), "BOTTOMLEFT", 25, -25)
	nkRWardrobe.extUI.aboutButton:SetText(nkRWardrobe.langTexts.tabHeader3)
	
	nkRWardrobe.extUI.aboutButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.ShowAboutInfo()
	end, "nkRW_cw_aboutButton_LeftClick")
	
	-- bottom button array: donate button
	
	nkRWardrobe.extUI.donateButton = UI.CreateFrame("RiftButton", "nkRW_cw_donateButton", nkRWardrobe.extUI)
	nkRWardrobe.extUI.donateButton:SetPoint("CENTERLEFT", nkRWardrobe.extUI.aboutButton, "CENTERRIGHT", 25, 0)
	nkRWardrobe.extUI.donateButton:SetText(nkRWardrobe.langTexts.btDonate)

	nkRWardrobe.extUI.donateButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		nkRWardrobe.ShowDonateInfo()
	end, "nkRW_cw_donateButton_LeftClick")
	
	-- bottom button array: version text
	
	nkRWardrobe.extUI.versionText = UI.CreateFrame("Text", "nkRW_cw_versionText", nkRWardrobe.extUI)
	nkRWardrobe.extUI.versionText:SetFontSize(13)
	nkRWardrobe.extUI.versionText:SetText(string.format(nkRWardrobe.langTexts.txtHeader, nkRWardrobe.privateVars.addonName, nkRWardrobe.privateVars.addonVersion))
	nkRWardrobe.extUI.versionText:SetFontColor(236, 228, 189, 1)
	nkRWardrobe.extUI.versionText:SetPoint("BOTTOMCENTER", nkRWardrobe.extUI:GetContent(), "BOTTOMCENTER")
	
	function UI.Native.Character.Event:Loaded() 
		nkRWardrobe.extUI:SetVisible(UI.Native.Character:GetLoaded()) 
	end	
																								
end

--==================== ADDITIONAL UI ELEMENTS ====================

function nkRWardrobe.ShowDonateInfo ()
	
	nkRWardrobe.messageDialog (nkRWardrobe.langTexts.about.donate1 .. ' ' .. nkRWardrobe.langTexts.about.donate2)
		
end

function nkRWardrobe.ShowAboutInfo () 

	if nkRWardrobe.UIelements.aboutUI == nil then nkRWardrobe.UIelements.aboutUI = nkRWardrobe.About() else nkRWardrobe.UIelements.aboutUI:SetVisible(true) end 

end


function nkRWardrobe.confirmDialog (message, yesFunc)

	if nkRWardrobe.UIelements.confirmDialog == nil then
		nkRWardrobe.UIelements.confirmDialog = nkUICreateFrame("nkDialog", "nkRW_confirmDialog", nkRWardrobe.UIelements.dialogContext)
		nkRWardrobe.UIelements.confirmDialog:SetWidth(500)
		nkRWardrobe.UIelements.confirmDialog:SetHeight(250)
		nkRWardrobe.UIelements.confirmDialog:SetType('confirm')
	end
	
	nkRWardrobe.UIelements.confirmDialog:SetMessage(message)
	nkRWardrobe.UIelements.confirmDialog:SetVisible(true)
	
	Command.Event.Detach(Library.nkUI.Event.nkRW_confirmDialog.LeftButtonClicked, nil, "nkRW_confirmDialog.LeftButtonClicked") -- delete possible earlier event handler and replace with new one
	
	Command.Event.Attach(Library.nkUI.Event.nkRW_confirmDialog.LeftButtonClicked, function ()
		yesFunc()
	end, "nkRW_confirmDialog.LeftButtonClicked")
		
end

function nkRWardrobe.messageDialog (message)

	if nkRWardrobe.UIelements.messageDialog == nil then
		nkRWardrobe.UIelements.messageDialog = nkUICreateFrame("nkDialog", "nkRW_messageDialog", nkRWardrobe.UIelements.dialogContext)
		nkRWardrobe.UIelements.messageDialog:SetWidth(500)
		nkRWardrobe.UIelements.messageDialog:SetHeight(200)
		nkRWardrobe.UIelements.messageDialog:SetType('message')
	end
	
	nkRWardrobe.UIelements.messageDialog:SetMessage(message)
	nkRWardrobe.UIelements.messageDialog:SetVisible(true)

end

--==================== HELPER FUNCTIONS ====================

---------- update ui elements on set select change ----------

function nkRWardrobe.UpdateUIOnSetChange(selSet)

	nkRWardrobe.extUI.bagSelect:SetSelectedValue(nkRWSetup.sets[selSet].bag, true)
	nkRWardrobe.extUI.bankSelect:SetSelectedValue(nkRWSetup.sets[selSet].bank, true)
	nkRWardrobe.extUI.roleSelect:SetSelectedValue(nkRWSetup.sets[selSet].role, true)
	nkRWardrobe.extUI.iconSelect:SetSelectedValue(nkRWSetup.sets[selSet].icon, true)

end

---------- update set selection combo ----------

function nkRWardrobe.UpdateSetSelectValues()

	local selItems= {}
	
	if nkRWSetup.sets[1] == nil then nkRWSetup.sets[1] = { name = string.format(nkRWardrobe.langTexts.txtEquipment, 1) } end
		
	for k, v in pairs (nkRWSetup.sets) do
		table.insert (selItems, { label = v.name, value = k })
	end
	
	nkRWardrobe.extUI.setSelect:SetSelection(selItems)
	
end

--==================== EXECUTION FUNCTIONS ====================

---------- store equip into set storage ----------

function nkRWardrobe.StoreEquip(loadToSet)

	local slotTable = {'helmet', 'shoulders', 'chest', 'gloves', 'belt', 'legs', 'feet', 'focus', 'handmain', 'handoff', 'ranged', 'neck', 'trinket', 'ring1', 'ring2', 'synergy', 'seal'}

	local funcYes = function ()
		local bank = nkRWSetup.sets[loadToSet].bank
		local bag = nkRWSetup.sets[loadToSet].bag
		local name = nkRWSetup.sets[loadToSet].name
		
		nkRWSetup.sets[loadToSet].items = {}
		
		for k, v in pairs (slotTable) do
			local equipSlot = Utility.Item.Slot.Equipment(v)
			local itemID = Inspect.Item.List (equipSlot)
			if itemID ~= false then 
				nkRWSetup.sets[loadToSet].items[v] = itemID 
			else
				nkRWSetup.sets[loadToSet].items[v] = nil
			end
		end
		
		nkRWSetup.sets[loadToSet].bank = bank
		nkRWSetup.sets[loadToSet].bag = bag
		nkRWSetup.sets[loadToSet].name = name
	end

	nkRWardrobe.confirmDialog (nkRWardrobe.langTexts.msgLoadCurrentEquip, funcYes)
	
end

---------- move equip from bank to bag ----------

function nkRWardrobe.GetEquipFromBank()

	local setNo = nkRWardrobe.extUI.fldSelEquipmentSet:getValue()

	local availSlots = {}
	local allSlots = nil
	
	if nkRWSetup.sets[setNo].bag ~= nil then
		local bagSlot = Utility.Item.Slot.Inventory(nkRWSetup.sets[setNo].bag)
		local bagInfo = Inspect.Item.List(bagSlot)
		
		for slot, details in pairs (bagInfo) do
			if details == false then table.insert (availSlots, slot) end		
		end
	end
	
	if #availSlots < 16 then	
		allSlots = Inspect.Item.List('si') 
		for slot, details in pairs (allSlots) do
			if nkTools.table.isMember (availSlots, slot) == false and details == false then table.insert (availSlots, slot) end		
		end
	end
	
	local bankSlots = Inspect.Item.List('sb')
	
	if #availSlots == 0 then return end
	
	for k, v in pairs (nkRWSetup.sets[setNo].items) do
		local err, retVal = pcall (Inspect.Item.Find, v)
		
		if err then
			if bankSlots[retVal] ~= nil then
				if #availSlots > 0 then 
					pcall (Command.Item.Move, retVal, availSlots[1])
					table.remove (availSlots, 1)
				end
			else
				local itemDetails = Inspect.Item.Detail(v)
				if itemDetails ~= nil then  print (string.format(nkRWardrobe.langTexts.errGettingItem, itemDetails.name)) end
			end
		end
	end

end

---------- move equip from bag to bank ----------

function nkRWardrobe.PutEquipToBank()

	local setNo = nkRWardrobe.extUI.fldSelEquipmentSet:getValue()

	local availSlots = {}
	local allSlots = nil
	
	if nkRWSetup.sets[setNo].bank ~= nil then
	
		local bankSlot = nil
		if nkRWSetup.sets[setNo].bank == 0 then 
			bankSlot = Utility.Item.Slot.Bank('main')
		else
			bankSlot = Utility.Item.Slot.Bank(nkRWSetup.sets[setNo].bank)
		end

		local bankInfo = Inspect.Item.List(bankSlot)
		
		for slot, details in pairs (bankInfo) do
			if details == false then table.insert (availSlots, slot) end
		end
		
	end

	if #availSlots < 16 then	
		allSlots = Inspect.Item.List('sb') 
		for slot, details in pairs (allSlots) do
			if nkTools..table.isMember (availSlots, slot) == false and details == false then table.insert (availSlots, slot) end		
		end
	end

	if #availSlots == 0 then return end
	
	local inventorySlots = Inspect.Item.List('si')
	local equipmentSlots = Inspect.Item.List('seqp')
		
	for k, v in pairs (nkRWSetup.sets[setNo].items) do
		if k ~= 'name' then
			local err, retVal = pcall (Inspect.Item.Find, v)
			
			if err then
				if (inventorySlots[retVal] ~= nil or equipmentSlots[retVal] ~= nil) and #availSlots > 0 then 
					pcall (Command.Item.Move, retVal, availSlots[1])
					table.remove (availSlots, 1)
				end
			end
		end
	end

end

---------- create new set ----------

function nkRWardrobe.SetAdd()

	local noOfSets = #nkRWSetup.sets
	nkRWSetup.sets[noOfSets+1] = { name = string.format(nkRWardrobe.langTexts.txtEquipment, noOfSets+1), bag = 1, bank = 0, items = {}, role = 1, icon = 'ressource/equipEmptyhandmain.png' }
	
	nkRWardrobe.UpdateSetSelectValues()
	nkRWardrobe.extUI.setSelect:SetSelectedValue( noOfSets + 1)
	nkRWardrobe.privateVars.uiSelectedSet = noOfSets + 1
	
end

---------- remove existing set ----------

function nkRWardrobe.SetRemove()

	if #nkRWSetup.sets == 1 then 
		nkRWardrobe.messageDialog(nkRWardrobe.langTexts.errLastSet)
	else
		local funcYes = function () 
			table.remove (nkRWSetup.sets, nkRWardrobe.privateVars.uiSelectedSet)			
			nkRWardrobe.UpdateSetSelectValues()
			nkRWardrobe.extUI.setSelect:SetSelectedValue(1)
			nkRWardrobe.privateVars.uiSelectedSet = 1
		end
		
		nkRWardrobe.confirmDialog (nkRWardrobe.langTexts.msgRemoveSetConfirm, funcYes)
	end
	
end

---------- copy existing set ----------

function nkRWardrobe.SetCopy()

	local noOfSets = #nkRWSetup.sets
	local newSet = nkTools.table.copy (nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet])
	newSet.name = string.format(nkRWardrobe.langTexts.txtCopiedSet, nkRWSetup.sets[nkRWardrobe.privateVars.uiSelectedSet].name)
	
	table.insert ( nkRWSetup.sets, newSet)
	
	nkRWardrobe.UpdateSetSelectValues()
	nkRWardrobe.privateVars.uiSelectedSet = #nkRWSetup.sets
	nkRWardrobe.extUI.setSelect:SetSelectedValue(#nkRWSetup.sets)

end

--==================== TOOLTIP INFO FRAME ====================

function nkRWardrobe.buildTooltipInfo ()

	local width =  UI.Native.Tooltip:GetWidth()

	nkRWardrobe.UIelements.tooltipInfo = UI.CreateFrame('Frame', 'nkRW_tooltipInfo', nkRWardrobe.UIelements.tooltipContext)
	nkRWardrobe.UIelements.tooltipInfo:SetWidth(width)
	nkRWardrobe.UIelements.tooltipInfo:SetHeight(20)
	nkRWardrobe.UIelements.tooltipInfo:SetBackgroundColor(0, 0, 0, 1)
	nkRWardrobe.UIelements.tooltipInfo:SetPoint("TOPLEFT", UI.Native.Tooltip, "BOTTOMLEFT")
	
	nkRWardrobe.UIelements.tooltipInfo.text = UI.CreateFrame("Text", "nkRW_tooltipInfo_text", nkRWardrobe.UIelements.tooltipInfo)
	nkRWardrobe.UIelements.tooltipInfo.text:SetFontSize(13)
	nkRWardrobe.UIelements.tooltipInfo.text:SetFontColor(1, 1, 1, 1)
	nkRWardrobe.UIelements.tooltipInfo.text:SetPoint("BOTTOMLEFT", nkRWardrobe.UIelements.tooltipInfo, "BOTTOMLEFT")
	
end

function nkRWardrobe.tooltipInfo ()	
	
	if nkRWardrobe.privateVars.lastTTDisplay == nil or os.time() - nkRWardrobe.privateVars.lastTTDisplay > 1 then
		if nkRWardrobe.UIelements.tooltipInfo ~= nil then nkRWardrobe.UIelements.tooltipInfo:SetVisible(false) end
	end
	
	local itemType, itemId = Inspect.Tooltip()
	if (itemType ~= "item" and itemType ~= "itemtype") then 
		--if nkRWardrobe.UIelements.tooltipInfo ~= nil then nkRWardrobe.UIelements.tooltipInfo:SetVisible(false) end	
		return 
	end
	
    local ttText = ""
	
	for key, details in pairs (nkRWSetup.sets) do
		if details.items ~= nil then
			for subkey, setItemID in pairs (details.items) do		
				if setItemID == itemId then				
					if ttText ~= "" then ttText = ttText .. ", " end
					ttText = ttText .. details.name
				end
			end
		end
	end
	
	if ttText ~= "" then
		if nkRWardrobe.UIelements.tooltipInfo == nil then nkRWardrobe.buildTooltipInfo() end	
		nkRWardrobe.UIelements.tooltipInfo:SetVisible(true)
		nkRWardrobe.UIelements.tooltipInfo.text:SetText(nkRWardrobe.langTexts.partOfSets .. ttText)		
		nkRWardrobe.privateVars.lastTTDisplay = os.time()
	elseif nkRWardrobe.privateVars.lastTTDisplay == nil or os.time() - nkRWardrobe.privateVars.lastTTDisplay > 1 then
		if nkRWardrobe.UIelements.tooltipInfo ~= nil then nkRWardrobe.UIelements.tooltipInfo:SetVisible(false) end
	end
	
end